# Examples

- **Simple** - All of these examples use automatic state management, meaning, they don't hoist any state out of the table or manually control anything. Start here for understanding the basics about how to build your table UI.
  - Basic
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/basic)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/basic)
  - Footers
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/footers)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/footers)
  - Sorting
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/sorting)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/sorting)
  - Filtering
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/filtering)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/filtering)
  - Grouping
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/grouping)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/grouping)
  - Grouping (Single Column)
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/grouping-column)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/grouping-column)
  - Pagination
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/pagination)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/pagination)
  - Row Selection
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/row-selection)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/row-selection)
  - Expanding
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/expanding)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/expanding)
  - Sub Components
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/sub-components)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/sub-components)
  - Editable Data
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/editable-data)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/editable-data)
  - Column Ordering
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/column-ordering)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/column-ordering)
  - Column Hiding
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/column-hiding)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/column-hiding)
  - Column Resizing
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/column-resizing)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/column-resizing)
  - Data-Driven Classes and Styles
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/data-driven-classes-and-styles)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/data-driven-classes-and-styles)
  - Row DnD
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/row-dnd)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/row-dnd)
  - Full Width Table (Table Elements with collapsible content)
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/full-width-table)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/full-width-table)
  - Full Width Resizable Table (via `useFlexLayout`)
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/full-width-resizable-table)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/full-width-resizable-table)
- **Complex**
  - The "Kitchen Sink"
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/kitchen-sink)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/kitchen-sink)
- **Controlled** - These examples are more advanced because they demonstrate how to manually control and respond to the state of the table.
  - Pagination (Controlled)
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/pagination-controlled)
    - [Open in CodeSandobx](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/pagination-controlled)
- **UI & Rendering** - These examples demonstrate how to use React Table with your favorite UI libraries or tools!
  - Virtualized Rows (React-Window)
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/virtualized-rows)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/virtualized-rows)
  - Animated (Framer-Motion)
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/animated-framer-motion)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/animated-framer-motion)
  - Material-UI
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/material-UI-components)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/material-UI-components)
  - Material-UI Enhanced Table
    - [Source](https://github.com/tannerlinsley/react-table/tree/master/examples/material-UI-enhanced-table)
    - [Open in CodeSandbox](https://codesandbox.io/s/github/tannerlinsley/react-table/tree/master/examples/material-UI-enhanced-table)
  - [ ] Styled-Components
  - [ ] CSS
  - [ ] Bootstrap
- Want to write one of these examples or add another? [Submit a PR!](https://github.com/tannerlinsley/react-table/compare)
